var ajax_admin_url                      = BoostrShippingAdminParams.ajax_url;
var sWeightTranslation                  = BoostrShippingAdminParams.sWeightTranslation;
var sPriceTranslation                   = BoostrShippingAdminParams.sPriceTranslation;
var sQuantityTranslation                = BoostrShippingAdminParams.sQuantityTranslation;
var sTitleTranslation                   = BoostrShippingAdminParams.sTitleTranslation;
var sMinimumTranslation                 = BoostrShippingAdminParams.sMinimumTranslation;
var sMaximumTranslation                 = BoostrShippingAdminParams.sMaximumTranslation;
var sShippingPriceTranslation           = BoostrShippingAdminParams.sShippingPriceTranslation;
var sBtnAddNewPriceRangeRowTranslation  = BoostrShippingAdminParams.sBtnAddNewPriceRangeRowTranslation;
var sCartTotalTranslation               = BoostrShippingAdminParams.sCartTotalTranslation;
var sCurrencySymbol                     = BoostrShippingAdminParams.sCurrencySymbol;
var sWeightUnit                         = BoostrShippingAdminParams.sWeightUnit;
var sShippingPriceTranslation           = BoostrShippingAdminParams.sShippingPriceTranslation;
var sShippingRangeHelperTextTranslation = BoostrShippingAdminParams.sShippingRangeHelperTextTranslation;
var sShippingRangeGuideLinkTranslation  = BoostrShippingAdminParams.sShippingRangeGuideLinkTranslation;


jQuery( document ).ready(
	function() {
		addHtmlAfterTarget( '.shipping_price', 'Weight', sWeightUnit );
		addHtmlAfterTarget( '.shipping_price', 'Price', sCurrencySymbol );

		jQuery( '.differentiated_price_type' ).on(
			'change',
			function() {
				sRangeType        = jQuery( '.differentiated_price_type' ).val();
				var aShippingData = {
					'action': 'boostr_shipping_get_price_ranges',
					'iInstance_id': jQuery.urlParam( 'instance_id' ),
					'sRangeType' : sRangeType,
				};

				jQuery.post(
					ajax_admin_url,
					aShippingData,
					function(response)
					{
						if (response) {
							if (response.success === true) {
								if (response.data != null && response.data != "undefined") {
									if (sRangeType == "Price") {
										sUnit = sCurrencySymbol;
									} else if (sRangeType == "Weight") {
										sUnit = sWeightUnit;
									}
									jQuery( '.' + sRangeType + '_div > table > tbody > .boostr_shipping_tr' ).remove();
									for (var oRow in response.data) {
										jQuery( '.' + sRangeType + '_div > table > tbody' ).append( RowToTablehtml( response.data[oRow].minimum, response.data[oRow].maximum, response.data[oRow].shipping_price, sUnit ) );
									}
								}
							}
						}
					}
				);

				if (jQuery( '.differentiated_price_type' ).val() == "Quantity") {
					jQuery( '.Weight_tr' ).hide();
					jQuery( '.Price_tr' ).hide();
					jQuery( '.shipping_price' ).parents().eq( 2 ).show();
				} else if (jQuery( '.differentiated_price_type' ).val() == 'Weight') {
					jQuery( '.shipping_price' ).parents().eq( 2 ).hide();
					jQuery( '.Price_tr' ).hide();
					jQuery( '.Weight_tr' ).show();
				} else if (jQuery( '.differentiated_price_type' ).val() == 'Price') {
					jQuery( '.shipping_price' ).parents().eq( 2 ).hide();
					jQuery( '.Weight_tr' ).hide();
					jQuery( '.Price_tr' ).show();
				}
			}
		).change();

			jQuery( '.button-add-new-price-range-row' ).on(
				'click',
				function()
				{
						sRangeType = jQuery( '.differentiated_price_type' ).val();
					if (sRangeType == "Price") {
						sUnit = sCurrencySymbol;
					} else if (sRangeType == "Weight") {
						sUnit = sWeightUnit;
					} else {
						sUnit = "";
					}

					jQuery( this ).parent().siblings( '.boostr_shipping_table' ).append( RowToTablehtml( "", "", "", sUnit ) );
				}
			);

			jQuery( document ).on(
				'click',
				'.button-delete-row' ,
				function()
				{
					if (jQuery( this ).parent().parent().parent().children( '.boostr_shipping_tr' ).length > 1) {
						jQuery( this ).parents().eq( 1 ).remove();
					}
				}
			);

			jQuery( document ).on(
				'change',
				'._input_shipping_price, .boostr_shipping_input_minimum, .boostr_shipping_input_maximum',
				function()
				{
						iMinimumPrice  = jQuery( this ).parent().parent().find( '.boostr_shipping_input_minimum' ).val();
						iMaximumPrice  = jQuery( this ).parent().parent().find( '.boostr_shipping_input_maximum' ).val();
						iShippingPrice = jQuery( this ).parent().parent().find( '.boostr_shipping_input_shipping_price' ).val();
						var bErrors    = false;

					if (iShippingPrice) {
						if ( ! isNumeric( iShippingPrice ) || parseInt( iShippingPrice ) < 0) {
							jQuery( this ).parent().parent().addClass( 'error-range-row' );
							bErrors = true;
						}
					}
					if (iMaximumPrice && iMinimumPrice) {
						if (parseInt( iMinimumPrice ) >= parseInt( iMaximumPrice ) || ! isNumeric( iMinimumPrice ) || ! isNumeric( iMaximumPrice )) {
							jQuery( this ).parent().parent().addClass( 'error-range-row' );
							bErrors = true;
						}
					}
					if ( ! bErrors) {
						jQuery( this ).parent().parent().removeClass( 'error-range-row' );
					}
				}
			);

			jQuery( '.woocommerce-save-button' ).on(
				'click',
				function(event)
				{
						var i                      = 1;
						boostr_shipping_price_rows = jQuery( '.boostr_shipping_tr:visible' );

						jQuery( '.boostr_shipping_input_maximum:visible, .boostr_shipping_input_minimum:visible, .boostr_shipping_input_shipping_price:visible' ).each(
							function()
							{
								if ( ! isNumeric( jQuery( this ).val() )) {
									jQuery( this ).parent().parent().addClass( 'error-range-row' );
								}
								if (jQuery( this ).parent().parent().hasClass( 'error-range-row' )) {
									event.preventDefault();
									return;
								}
							}
						);

						oShippingRows = '{"oRows":[';
						jQuery( boostr_shipping_price_rows ).each(
							function()
							{
									minimum_range        = jQuery( this ).find( '.boostr_shipping_td_minimum > input' ).val();
									maximum_range        = jQuery( this ).find( '.boostr_shipping_td_maximum > input' ).val();
									shipping_price_range = jQuery( this ).find( '.boostr_shipping_td_shipping_price > input' ).val();
									oShippingRows       += '{"minimum": "' + minimum_range + '", "maximum": "' + maximum_range + '", "shipping_price": "' + shipping_price_range + '"}';
								if (boostr_shipping_price_rows.length > i ) {
									oShippingRows += ',';
								}
									i = i + 1;
							}
						);
						oShippingRows += ']}';

						var data = {
							'sRangeType' : jQuery( '.differentiated_price_type' ).val(),
							'iInstance_id': jQuery.urlParam( 'instance_id' ),
							'oShippingRows' : oShippingRows,
					};
						jQuery( '.hidden_post_field' ).val( JSON.stringify( data ) );
				}
			);

	}
);

jQuery.urlParam = function(name){
	var results = new RegExp( '[\?&]' + name + '=([^&#]*)' ).exec( window.location.href );
	if (results == null) {
		return null;
	} else {
		return results[1] || 0;
	}
};

function isNumeric(n)
{
	return ! isNaN( parseFloat( n ) ) && isFinite( n );
}

function RowToTablehtml(minimum, maximum, shipping_price, symbol)
{
	var range_row_html =
		'<tr class="boostr_shipping_tr">' +
		'<td class="boostr_shipping_td_minimum">' +
		'<input class="boostr_shipping_input_minimum" type="text" placeholder="' + symbol + '" value="' + minimum + '" >' +
		'</td>' +
		'<td clas="boostr_shipping_unit_td_wrapper">' +
		'<div class="boostr_shipping_unit_wrapper">' +
		'<div class="boostr_shipping_minimum_sign_wrapper"><</div><div class="boostr_shipping_cart_total_wrapper">' + sCartTotalTranslation + '</div><div class="boostr_shipping_maximum_sign_wrapper"><=</div>' +
		'</div>' +
		'</td>' +

		'<td class="boostr_shipping_td_maximum">' +
		'<input class="boostr_shipping_input_maximum" type="text" placeholder="' + symbol + '" value="' + maximum + '">' +
		'</td>' +
		'<td class="boostr_shipping_td_shipping_price">' +
		'<input class="boostr_shipping_input_shipping_price" type="text" placeholder="' + sShippingPriceTranslation + '" value="' + shipping_price + '">' +
		'</td>' +
		'<td class="boostr_shipping_td_delete_row">' +
		'<input class="button-secondary button-delete-row" value="x" type="button">' +
		'</td>' +
		'</tr>';
	return range_row_html;
}

function addHtmlAfterTarget(target, html_class, symbol)
{
	if (html_class == "Price") {
		th_text = sPriceTranslation;
	} else {
		th_text = sWeightTranslation;
	}

	var tr_html =

		'<tr style="display: none;" class="' + html_class + '_tr" valign="top">' +
		'<th></th>' +
		'<td class="' + html_class + '_td">' +
		//'<div>' + sTitleTranslation + ' ' +th_text+'</div>' +
		'<div class="' + html_class + '_div">' +
		'<table class="' + html_class + '_boostr_shipping_table boostr_shipping_table">' +
		'<tr>' +
		'<th>' +
		sMinimumTranslation + ' ' + th_text + ' (' + symbol + ')' +
		'</th>' +
		'<th>' +
		'</th>' +
		'<th>' +
		sMaximumTranslation + ' ' + th_text + ' (' + symbol + ')' +
		'</th>' +
		'<th>' +
		sShippingPriceTranslation +
		'</th>' +
		'</tr>' +
		RowToTablehtml( "", "", "", symbol ) +
		'</table>' +
		'<div class="save_and_addnew_wrapper">' +
		'<input class="boostr_shipping_range_type" type="hidden" value="' + html_class + '" ></input>' +
		'<input class="button-secondary button-add-new-price-range-row" value="' + sBtnAddNewPriceRangeRowTranslation + '" type="button">' +
		'</div>' +
		'</div>' +
		'</td>' +
		'</tr>';
	jQuery( tr_html ).insertAfter( jQuery( target ).parents().eq( 2 ) );
	jQuery( '.' + html_class + '_td' ).prepend( '<div class="boostr_shipping_range_helper_text">' + sShippingRangeHelperTextTranslation + '</div>' );
}
