jQuery(
	function ( $ ) {
		if ( typeof boostr_shipping_orders_params === 'undefined' ) {
			return false;
		}

		$( '#custom_tracktrace_enable_own_tt' ).on(
			'click',
			function() {
				$( '#gls_send_tracktrace > .inside' ).css( 'position', 'relative' ).append( '<div class="blockUI blockOverlay boostr-shipping-loader"></div>' );

				var data = {
					'action': 'custom_tracktrace_enable_own_tt',
					'post_id': $( '#gls_post_id' ).val(),
					'track_and_trace_ID': $( '#custom_gls_tracktrace' ).val(),
					'_wpnonce': boostr_shipping_orders_params.nonce,
				};

				$.post(
					boostr_shipping_orders_params.ajax_url,
					data,
					function (response) {
						if (response) {
							var returned = JSON.parse( response );

							if (returned.error) {
								alert( returned.error );
								$( '#gls_send_tracktrace > .inside' ).parent().find( '.blockUI' ).remove();
							} else if (returned.success) {
								$( '#custom_gls_tracktrace' ).val( returned.track_and_trace_id );
								$( '#postcustomstuff input[value="tracktrace_id"]' ).closest( 'tr' ).find( 'textarea' ).val( returned.track_and_trace_id );
								$( '#gls_send_tracktrace > .inside' ).parent().find( '.blockUI' ).remove();
							}
						} else {
							$( '#gls_send_tracktrace > .inside' ).parent().find( '.blockUI' ).remove();
							alert( boostr_shipping_orders_params.strings.an_error_occured );
						}
					}
				);
			}
		);

		$( '#send_gls_tracktrace' ).on(
			'click',
			function() {
				$( '#gls_send_tracktrace > .inside' ).css( 'position', 'relative' ).append( '<div class="blockUI blockOverlay boostr-shipping-loader"></div>' );

				var data = {
					'action': 'gls_send_tracktrace',
					'post_id': $( '#gls_post_id' ).val(),
					'_wpnonce': boostr_shipping_orders_params.nonce,
				};

				if ($( '#send_gls_tracktrace' ).is( ":visible" )) {
					$( '#send_gls_tracktrace' ).prop( 'disabled', true );
				}

				$.post(
					boostr_shipping_orders_params.ajax_url,
					data,
					function (response) {
						if (response) {
							var returned = JSON.parse( response );

							if (returned.error) {
								alert( returned.error );
							} else if (returned.success) {
								$( '.track_and_trace_table > tbody' ).append( '<tr><td>' + returned.tracktrace_history_json['date'] + '</td><td>' + returned.tracktrace_history_json['time'] + '</td><td>' + returned.tracktrace_history_json['tracktraceID'] + '</td></tr>' );

								if ($( '#send_gls_tracktrace' ).is( ":visible" )) {
									$( '#send_gls_tracktrace' ).prop( 'disabled', false );
								}

								$( '#send_gls_tracktrace' ).val( boostr_shipping_orders_params.strings.send_tt_mail_again );
								$( '#gls_send_tracktrace > .inside' ).parent().find( '.blockUI' ).remove();
							}
						} else {
							alert( boostr_shipping_orders_params.strings.an_error_occured );
						}
					}
				);
			}
		);

		$( '#get_gls_label' ).on(
			'click',
			function () {
				$( '#gls_get_label > .inside' ).css( 'position', 'relative' ).append( '<div class="blockUI blockOverlay boostr-shipping-loader"></div>' );

				if ( $( '#gls_ship_date' ).val() !== '' ) {
					var data = {
						'action': 'gls_get_label',
						'post_id': $( '#gls_post_id' ).val(),
						'gls_ship_date': $( '#gls_ship_date' ).val(),
						'gls_ship_weight': $( '#gls_weight' ).val(),
						'_wpnonce': boostr_shipping_orders_params.nonce,
					};

					if ($( '#download_gls_label' ).is( ":visible" )) {
						$( '#download_gls_label' ).prop( 'disabled', true );
						$( '#send_gls_tracktrace' ).prop( 'disabled', true );
					}

					$.post(
						ajaxurl,
						data,
						function (response) {
							if (response) {
								if (response.error) {
									$( '#gls_get_label > .inside' ).parent().find( '.blockUI' ).remove();
									alert( response.error );
								} else if (response.file) {
									if ($( '#download_gls_label' ).is( ":visible" )) {
										$( '#download_gls_label' ).prop( 'disabled', false );
										$( '#send_gls_tracktrace' ).prop( 'disabled', false );
									} else {
										$( '#send_gls_tracktrace' ).show();
										$( '#download_gls_label' ).show();
									}
									$( '#gls_get_label > .inside' ).parent().find( '.blockUI' ).remove();
								}

								if (response.file_return_label) {
									$( 'a#download_return_label' ).show();
								}

							} else {
								$( '#gls_get_label > .inside' ).parent().find( '.blockUI' ).remove();
								alert( boostr_shipping_orders_params.strings.an_error_occured );
							}
						}
					);
				} else {
					$( '#gls_get_label > .inside' ).parent().find( '.blockUI' ).remove();
					alert( boostr_shipping_orders_params.strings.please_select_a_date );
				}
			}
		);

		$( '#gls_ship_date' ).datepicker(
			{
				dateFormat: "dd-mm-yy",
				minDate: new Date()
			}
		).datepicker( "setDate", "0" );
	}
);
