var sDataRoot             = BoostrShippingParams.plugin_root; // Root path to data directory (Variable passed from mainfile)
var sSelected_shop_header = BoostrShippingParams.selected_shop_header; //Text on selected shop div (Variable passed from mainfile)
var sMonday               = BoostrShippingParams.sMonday;
var sTuesday              = BoostrShippingParams.sTuesday;
var sWednesday            = BoostrShippingParams.sWednesday;
var sThursday             = BoostrShippingParams.sThursday;
var sFriday               = BoostrShippingParams.sFriday;
var sSaturday             = BoostrShippingParams.sSaturday;
var sSunday               = BoostrShippingParams.sSunday;
var sWrongLicensCode      = BoostrShippingParams.sWrongLicensCode;
var sPacketshop           = BoostrShippingParams.sPacketshop;
var sNoPacketshopClose    = BoostrShippingParams.sNoPacketshopClose;
var sSorryDisabledCountry = BoostrShippingParams.sSorryDisabledCountry;
var sEnterZipcode         = BoostrShippingParams.sEnterZipcode;
var sError_no_shops_found = BoostrShippingParams.error_no_shops_found;
var sAjax_url             = BoostrShippingParams.ajax_url;
var sError_no_cords_found = BoostrShippingParams.error_no_cords_found
var sMarkerIcon           = ''; // Data marker icon
var oDefaultLatlng        = new google.maps.LatLng( 55.9150835, 10.4713954 ); // Set default map properties
var iDefaultZoom          = 5; // Zoom level of the map
var iDefaultMaxZoom       = 18; // Max zoom level of the map
var map; // Variable for map
var oInfowindow; // Variable for marker info window
var aBoostr_marker_list = {};
var bounds              = ''; // Set bounds
var aMyOptions          = {
	zoom: iDefaultZoom,
	center: oDefaultLatlng,
	maxZoom: iDefaultMaxZoom,
	mapTypeId: google.maps.MapTypeId.Road
}; // Option for google map object



function getShopList(sShipping_agent, iZipcode)
{
		var iTrimZipcode = iZipcode.trim();
		sMarkerIcon      = sShipping_agent + '.png';
		var aData        = {
			'action': 'boostr_shipping_get_shop_list',
			'agent': sShipping_agent,
			'zipcode': iTrimZipcode,
	};
		jQuery.post(
			sAjax_url,
			aData,
			function(sResponse){

				if (sResponse) {

					sResponse = sResponse.replaceAll( 'Monday', sMonday );
					sResponse = sResponse.replaceAll( 'Tuesday', sTuesday );
					sResponse = sResponse.replaceAll( 'Wednesday', sWednesday );
					sResponse = sResponse.replaceAll( 'Thursday', sThursday );
					sResponse = sResponse.replaceAll( 'Friday', sFriday );
					sResponse = sResponse.replaceAll( 'Saturday', sSaturday );
					sResponse = sResponse.replaceAll( 'Sunday', sSunday );

					sResponse = sResponse.replaceAll( 'Sorry, the license key used for this shipping method didnt work', sWrongLicensCode );
					sResponse = sResponse.replaceAll( 'Packetshop:', sPacketshop );
					sResponse = sResponse.replaceAll( 'Couldnt find any pickup point close to the choosen zipcode', sNoPacketshopClose );
					sResponse = sResponse.replaceAll( 'Sorry, this shipping with this method for your choosen country is currently disabled', sSorryDisabledCountry );
					sResponse = sResponse.replaceAll( 'You must enter a zipcode, to see the nearest pickup points - please try again', sEnterZipcode );

					var oReturned = JSON.parse( sResponse );

					if (oReturned.status === false) {
						jQuery( '.woocommerce-shipping-totals .boostr-shipping-loader' ).remove();
						alert( oReturned.error );
					} else if (oReturned.status === true) {
						if (oReturned.hidden_boostr_shipping) {
							jQuery( '#boostr-shipping-modal' ).modal(
								{
									show: true,
									backdrop: true,
								}
							);

							jQuery( '#boostr-shipping-modal #inner-modal-buddy' ).html( oReturned.shoplist );
							jQuery( '#boostr-shipping-modal #map_wrapper .map_content_wrapper' ).html( oReturned.map );
							jQuery( '#boostr_shipping_hidden_radio' ).html( oReturned.hidden_boostr_shipping );
							oMarkerFile                 = oReturned.shoplist_json;
							oUndefined_cords_markerFile = new Array();

							for (var key in oMarkerFile) {
								if ( ! oMarkerFile[key].hasOwnProperty( 'latitude' ) || ! oMarkerFile[key].hasOwnProperty( 'longitude' )) {
									oUndefined_cords_markerFile[key] = oMarkerFile[key];
									delete oMarkerFile[key];
								}
							}

							//loads the map and other map related stuff
							loadMap();

							//loads any markers that already have cords
							if (Object.keys( oMarkerFile ).length >= 1) {
								jQuery( oMarkerFile ).each(
									function()
									{
											loadMarker( this );
									}
								)
							}

							//checks if their is any markers, that have no lng or lat that needs to be loaded
							if (Object.keys( oUndefined_cords_markerFile ).length > 0) {
								load_markers_without_cords_from_streetname( oUndefined_cords_markerFile )
							}

							setTimeout(
								function()
								{
										jQuery( '.woocommerce-shipping-totals .boostr-shipping-loader' ).remove();
										google.maps.event.trigger( map, 'resize' );
										map.fitBounds( bounds );
								},
								1000
							)
						} else {
							if (oReturned.return_error) {
								jQuery( '.woocommerce-shipping-totals .boostr-shipping-loader' ).remove();
								alert( oReturned.return_error );
							} else {
								jQuery( '.woocommerce-shipping-totals .boostr-shipping-loader' ).remove();
								alert( sError_no_shops_found );
							}
						}
					}
				} else {
					jQuery( '.woocommerce-shipping-totals .boostr-shipping-loader' ).remove();
					if (typeof oReturned != "undefined") {
						alert( oReturned.error );

					} else {
						//if it wasn't possible to connect to server.
						alert( 'Something went wrong. please try again later' );
					}
				}
			}
		);
}


function load_markers_without_cords_from_streetname(aMarkerFile)
{
	var geocoder = new google.maps.Geocoder();
	jQuery( aMarkerFile ).each(
		function(key)
		{
				var sAddress = this.address + ", " + this.city + ", " + this.zipcode
				var iShopid  = this.number
				geocoder.geocode(
					{'address': sAddress},
					function(results, status) {
						if (status === google.maps.GeocoderStatus.OK) {
							aMarkerFile[key].latitude  = results[0].geometry.location.lat() + "";
							aMarkerFile[key].longitude = results[0].geometry.location.lng() + "";
							loadMarker( aMarkerFile[key] );
						} else {
							jQuery( '[data-shopid="' + iShopid + '"] > div' ).append( '<div class="no_cords_found">' + sError_no_cords_found + '</div>' );
						}
					}
				)
		}
	)
	return aMarkerFile;
}


//loads the map and other map related stuff
function loadMap()
{
	// Create new map and place it in the target DIV
	map = new google.maps.Map( document.getElementById( "map-canvas" ), aMyOptions );
	// Create new info window for marker detail pop-up
	oInfowindow = new google.maps.InfoWindow();
	bounds      = new google.maps.LatLngBounds();
}


//loades a single marker (used by loaderMarkers())
function loadMarker(markerData)
{
	// Create new marker location
	var myLatlng = new google.maps.LatLng( markerData['latitude'], markerData['longitude'] );

	// Create new marker
	var marker = new google.maps.Marker(
		{
			map: map,
			position: myLatlng,
			icon: sDataRoot + '/assets/images/' + sMarkerIcon
		}
	);

	// Add information to the marker
	google.maps.event.addListener(
		marker,
		'click',
		(function (marker) {
			return function () {
				var shop_list = jQuery( '.shoplist > ul >li' );
				oInfowindow.setContent( shop_list.filter( '[data-shopid=' + markerData['number'] + ']' ).children().html() );
				oInfowindow.open( map, marker );
				shop_list.filter( '[data-shopid=' + markerData['number'] + ']' ).trigger( 'click' );
				//shop_list.removeClass('selected').filter('[data-shopid=' + markerData['number'] + ']').trigger('click').addClass('selected');
				jQuery( '#shop_radio_' + markerData['number'] ).trigger( 'click' );

				//adds the shop information to the #selected_shop div
				jQuery( '#selected_shop_header' ).html( sSelected_shop_header );
			}
		})( marker )
	);
	bounds.extend( marker.position );
	//adds a marker to the list of markers
	aBoostr_marker_list[markerData['number']] = marker;

	if (markerData['number'] == jQuery( '#hidden_choosen_shop' ).attr( 'shopid' )) {
		jQuery( 'li[data-shopid="' + markerData['number'] + '"' ).trigger( 'click' );
	};
}


//When a LI with a shop is pressed, the assosiated marker will have its informationwindow opened
function li_addlistener_open_marker(eventElement)
{
	var event = eventElement;
	jQuery.each(
		aBoostr_marker_list,
		function(key, value)
		{
			if (key == event.attr( 'data-shopid' )) {
				jQuery( '#hidden_choosen_shop' ).attr( 'shopid', event.attr( 'data-shopid' ) );
				//adds the shop information to the #selected_shop div
				jQuery( '#selected_shop_header' ).html( sSelected_shop_header );
				jQuery( '#selected_shop_context' ).html( eventElement.children().html() );
				//adds the shop information to the marker corresponding with the shop
				oInfowindow.setContent( eventElement.children().html() );
				oInfowindow.open( map,value );
			}
		}
	);
}

String.prototype.replaceAll = function(search, replacement) {
	var target = this;
	return target.replace( new RegExp( search, 'g' ), replacement );
};


//adds a toggle class to the show_map button
jQuery( document ).ready(
	function() {
		jQuery( ".js-show_map" ).on(
			"click",
			function()
			{
				if (jQuery( '#boostr-shipping-modal' ).hasClass( 'map_wrapper_open' ) || jQuery( '#boostr-shipping-modal' ).hasClass( 'map_wrapper_closed' )) {
					jQuery( "#boostr-shipping-modal" ).toggleClass( 'map_wrapper_closed map_wrapper_open' );
				} else {
					jQuery( "#boostr-shipping-modal" ).toggleClass( 'map_wrapper_open' );
				}
					google.maps.event.trigger( map, 'resize' );
					map.fitBounds( bounds );
					map.panToBounds( bounds );
			}
		);
		jQuery( '#boostr-shipping-modal' ).on(
			'hidden.bs.modal',
			function () {
				jQuery( this ).removeClass( 'map_wrapper_open map_wrapper_closed' );
			}
		)
	}
);
