<?php
/**
 * Plugin Name: Plugins.dk GLS shipping for WooCommerce
 * Plugin URI: https://plugins.dk
 * Description: GLS shipping for WooCommerce.
 * Version: 2.4.2
 * Text Domain: woocommerce-boostr-shipping
 * Author: plugins.dk
 * Author URI: https://plugins.dk
 * Requires at least: 4.5.2
 * Tested up to: 5.6
 * WC tested up to: 4.9
 */
defined( 'ABSPATH' ) || exit;

define( 'BOOSTR_SHIPPING_PLUGIN_FILE', __FILE__ );
define( 'BOOSTR_SHIPPING_PLUGIN_BASENAME', plugin_basename( __FILE__ ) );
define( 'BOOSTR_SHIPPING_PLUGIN_BASENAME_DIRNAME', dirname( plugin_basename( __FILE__ ) ) );
define( 'BOOSTR_SHIPPING_PLUGIN_URL', plugins_url( '', __FILE__ ) );
define( 'BOOSTR_SHIPPING_PLUGIN_DIR', dirname( __FILE__ ) );
define( 'BOOSTR_SHIPPING_VERSION', '2.4.2' );

define( 'BOOSTR_SHIPPING_SECRET_KEY', '578c8b22d6cfd7.08501487' );
define( 'BOOSTR_SHIPPING_LICENSE_SERVER_URL', 'https://boostr.internal.mshost.dk' );
define( 'BOOSTR_SHIPPING_ITEM_REFERENCE', 'Boostr_Shipping' );

add_action( 'plugins_loaded', 'boostr_shipping_init', 0 );

function boostr_shipping_init() {
	// Only load if WooCommerce is active.
	if ( ! class_exists( 'WooCommerce' ) ) {
		return;
	}

	if ( ! class_exists( 'Boostr_Shipping_Admin' ) ) {
		include_once 'includes/boostr_shipping_admin.php';
		new Boostr_Shipping_Admin();
	}
}
