<?php

defined( 'ABSPATH' ) || exit;

require_once BOOSTR_SHIPPING_PLUGIN_DIR . '/includes/boostr_shipping_main.php';
/**
 * Sample instance based method.
 */
class Boostr_Shipping_GLS_Private extends Boostr_Shipping_Main {


	/**
	 * Constructor. The instance ID is passed to this.
	 */
	public function __construct( $instance_id = 0 ) {
		$this->id                 = 'boostr_shipping_gls_private';
		$this->instance_id        = absint( $instance_id );
		$this->method_title       = __( 'GLS private', 'woocommerce-boostr-shipping' );
		$this->method_description = __( 'Adds the option to ship with the GLS private to the checkout', 'woocommerce-boostr-shipping' );
		$this->supports           = array(
			'shipping-zones',
			'instance-settings',
		);
		$this->init();
	}


	/* add the diffrent actions */
	public function addActions() {
		//adds the shipping method to the WooCommerce
		add_filter( 'woocommerce_shipping_methods', array( $this, 'register_shipping_method' ) );

		add_action( 'woocommerce_checkout_update_order_meta', array( $this, 'boostr_shipping_checkout_update_order_meta_gls_method_private' ) );
	}

	public function addFilters() {

	}

	public function boostr_shipping_checkout_update_order_meta_gls_method_private( $order_id ) {
		global $woocommerce;
		$choosen_shipping_method1 = preg_replace( '/\d/', '', $woocommerce->session->chosen_shipping_methods[0] );
		$choosen_shipping_method2 = preg_replace( '/\d/', '', $woocommerce->session->chosen_shipping_methods );
		if ( $choosen_shipping_method1 == 'boostr_shipping_gls_private' || $choosen_shipping_method2 == 'boostr_shipping_gls_private' ) {
			if ( $_POST['billing_address_1'] && ! $_POST['shipping_address_1'] ) {
				update_post_meta( $order_id, '_shipping_address_1', $_POST['billing_address_1'] );
				update_post_meta( $order_id, '_shipping_city', $_POST['billing_city'] );
				update_post_meta( $order_id, '_shipping_postcode', $_POST['billing_postcode'] );
			} elseif ( $_POST['shipping_address_1'] ) {
				update_post_meta( $order_id, '_shipping_address_1', $_POST['shipping_address_1'] );
				update_post_meta( $order_id, '_shipping_city', $_POST['shipping_city'] );
				update_post_meta( $order_id, '_shipping_postcode', $_POST['shipping_postcode'] );
			}
		}
	}

	/* Register the shipping method in WooCommerce*/
	public function register_shipping_method( $methods ) {
		$methods['boostr_shipping_gls_private'] = 'Boostr_Shipping_GLS_Private';
		return $methods;
	}
}

$boostr_GLS_Private = new Boostr_Shipping_GLS_Private();
$boostr_GLS_Private->mainAddAction();
$boostr_GLS_Private->addActions();
$boostr_GLS_Private->addFilters();
